#include <fstream>
#include <iostream>
#include <string>
#include <list>
#include <algorithm>
#include <stdexcept>

using std::endl;
using std::cout;
using std::cerr;
using std::cin;
using std::string;

class missing_name_exception: public std::invalid_argument {
public:
    missing_name_exception(string reason):invalid_argument(reason){ ; }
    missing_name_exception(const missing_name_exception & ex):invalid_argument(ex){ ; }
//    ~missing_name_exception() throw (){ ; }

};

class Person {
public:
    Person(string name) throw (missing_name_exception){
        if (name.empty()){
            missing_name_exception ex("Class Person does not support nameless persons.");
            throw ex;
        }
        m_name = name;
        cout << m_name << " is alive!" << endl;
    }

private:
    string m_name;
};

void foo(){
    Person karel("Karel");
    Person tom("Tom");
    Person jane_doe("");
    Person milan("Milan");
    Person monika("Monika");
}
int main (){

    try {
        foo();
    } catch(missing_name_exception ex){
        cout << ex.what() << endl;
    } catch(std::invalid_argument ex){
        cout << ex.what() << endl;
    }

    return 0;
}
